SystemOrganization addCategory: #'Glamour-Presentations'!

GLMPresentation subclass: #GLMFormatedPresentation
	instanceVariableNames: 'formater format'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

GLMFormatedPresentation subclass: #GLMFlexiblePresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMFlexiblePresentation commentStamp: '<historical>' prior: 0!
A presentation that flexibly changes it behavior depending on the current entity.

If the entity is a collection, this class renders as a ListPresentation, otherwise as a TextPresentation.!

!GLMFlexiblePresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
currentPresentation 
	 
	^self displayValue isCollection 
		ifTrue: [GLMListPresentation new pane: self pane] 
		ifFalse: [GLMTextPresentation new pane: self pane]! !

!GLMFlexiblePresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^self currentPresentation renderGlamorouslyOn: aRenderer! !

!GLMFormatedPresentation classSide methodsFor: 'instance creation' stamp: ' 4/5/09 22:18'!
formater: aBlock 
	 
	^(self new) 
		formater: aBlock; 
		yourself! !

!GLMFormatedPresentation methodsFor: 'private' stamp: ' 4/5/09 22:18'!
defaultFormater 
	 
	^#glamourString! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
format 
	 
	^format ifNil: [format _ self defaultFormater]! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
format: anObject 
	 
	format _ anObject! !

!GLMFormatedPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
formatedDisplayValue 
	 
	^self format glamourValue: self displayValue! !

GLMFormatedPresentation subclass: #GLMListPresentation
	instanceVariableNames: 'multipleSelection highlightPort itemActions isSearchable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMListPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
beMultiple 
	 
	multipleSelection _ true! !

!GLMListPresentation methodsFor: 'accessing' stamp: 'tg 5/20/2009 14:05'!
beSearchable
	isSearchable := true! !

!GLMListPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
beSingle 
	 
	multipleSelection _ false! !

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 5/20/2009 14:06'!
isMultiple 
	^ multipleSelection ifNil: [multipleSelection := false]! !

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 5/20/2009 14:05'!
isSearchable
	^ isSearchable ifNil: [isSearchable := false]! !

!GLMListPresentation methodsFor: 'testing' stamp: 'tg 5/20/2009 14:06'!
isSingle 
	^ self isMultiple not! !

!GLMListPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderListPresentation: self! !

GLMFormatedPresentation subclass: #GLMTextPresentation
	instanceVariableNames: 'text selectedText cursorPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
cursorPosition 
	 
	^cursorPosition! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
cursorPosition: anObject 
	 
	cursorPosition _ anObject! !

!GLMTextPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTextPresentation: self! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
selectedText 
	 
	^selectedText! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
selectedText: anObject 
	 
	selectedText _ anObject! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
text 
	 
	^text ifNil: [text _ self formatedDisplayValue]! !

!GLMTextPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
text: anObject 
	 
	text _ anObject! !

GLMFormatedPresentation subclass: #GLMTreePresentation
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMTreePresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children 
	 
	^children! !

!GLMTreePresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
children: anObject 
	 
	children _ anObject! !

!GLMTreePresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderTreePresentation: self! !

GLMFormatedPresentation subclass: #GLMWorkspacePresentation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMWorkspacePresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderWorkspacePresentation: self! !

GLMPresentation subclass: #GLMMondrianPresentation
	instanceVariableNames: 'painting'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Glamour-Presentations'!

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting 
	 
	^painting! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
painting: anObject 
	 
	painting _ anObject! !

!GLMMondrianPresentation methodsFor: 'rendering' stamp: ' 4/5/09 22:18'!
renderGlamorouslyOn: aRenderer 
	 
	^aRenderer renderMondrianPresentation: self! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 4/5/09 22:18'!
renderOn: aView 
	 
	self painting 
		glamourValue: 
			((self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: aView) , self entity] 
				ifFalse: 
					[GLMMultiValue 
						with: aView 
						with: self entity])! !

!GLMMondrianPresentation methodsFor: 'accessing' stamp: ' 25/2/09 23:39'!
renderView 
	 
	| view | 
	view := ViewRenderer new. 
	self painting 
		glamourValue: 
			((self entity isKindOf: GLMMultiValue) 
				ifTrue: [(GLMMultiValue with: view) , self entity] 
				ifFalse: 
					[GLMMultiValue 
						with: view 
						with: self entity]). 
	^view! !
